moSetGetInputOutputSr = {};

function moSetGetInputOutputSr:getSr(self, objectTable, xmlModString)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	local hasenzucht = false;
	local lammzucht = false;
	local srzucht = false;
	if string.find(xmlModString, "_") then		
		local splitXmlModString = Utils.splitString("_", xmlModString);		
		if #splitXmlModString > 0 then xmlModString = splitXmlModString[1];end;
	end;
	if objectTable ~= nil and string.lower(objectTable.animal) == xmlModString then
		--local numAnimalGe = "num"..xmlModString;
		--local numAnimalEn;
		
		
		if objectTable.HaseZuchtDirtyFlag ~= nil then
			if objectTable.numRabbit > 0 or objectTable.numHase > 0 then hasenzucht = true;end;			
		end;
		if objectTable.LammZuchtDirtyFlag ~= nil then
			if objectTable.numLamb > 0 or objectTable.numLamm > 0 then lammzucht = true;end;			
		end;
		if objectTable.SchweineZuchtDirtyFlag ~= nil then
			if objectTable.numPig > 0 or objectTable.numSchweine > 0 then srzucht = true;end;			
		end;
		if hasenzucht or lammzucht or srzucht then
			function setVm()
				if moGeneralSettings.viehmarkt then
					if moMapObjects.vm[1] == nil then return;end;
					for a=1, table.getn(moMapObjects.vm) do							
						for k, v in pairs(moMapObjects.vm[a].fillTypes) do							
							if moFillTypes[v] ~= nil and moFillTypes[v].descName ~= nil then
								fillName = moFillTypes[v].descName;								
								if string.find(fillName, "Missing") then							
									local splitMissing = Utils.splitString(" ", fillName);
									fillName = splitMissing[2]
								end;								
								if string.find(string.lower(fillName), xmlModString) and moMapObjects.vm[a].priceMultipliers[moMapObjects.vm[a].fillTypes[k]] ~= nil then
									local info = {};
									info.fillLevel = 0;
									info.capacity = -2;									
									info.pricePerLiter = getVmPrice(self, xmlModString, moMapObjects.vm[a].priceMultipliers[moMapObjects.vm[a].fillTypes[k]]);
									info.fillTypeName = tostring(moLanguageXml:getTxt("a_vm", nil, "Animalmarket"));	
									info.extraText = tostring(moLanguageXml:getTxt("on", nil, "On"));
									info.setColor = moGuiMiniPdaSlots.warningColor1;
									info.lengthFillTypes = 1;
									outputFillTypes[container] = {};
									table.insert(outputFillTypes[container], info);
									container = container+1;
								end;									
							end;
						end;
					end;
				end;
			end;
			function setAllValues()		
				local info = {};
				local srTyp = tostring(moLanguageXml:getTxt("a_breeding", nil, "(breeding)"));
				if objectTable.fattening ~= nil and objectTable.fattening then srTyp = tostring(moLanguageXml:getTxt("a_mast", nil, "(mast)"));end;
				info.fillTypeName = getAnimalRegName(self, xmlModString).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount")).. tostring(srTyp);
				info.lengthFillTypes = 1;
				info.pricePerLiter = getAnimalStorePrice(self, objectTable.name);		
				info.fillLevel = 0;
				if hasenzucht then
					info.fillLevel = Utils.getNoNil(objectTable.numRabbit, 0);
				elseif lammzucht then
					info.fillLevel = Utils.getNoNil(objectTable.numLamb, 0);
				else
					info.fillLevel = Utils.getNoNil(objectTable.numPig, 0);
				end;
				info.capacity = -1;
				info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.Produktivi*100, 0));--Utils.getNoNil(objectTable.Produktivi*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
				info.productivityColor = getAnimalsProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];				
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;		
			end;
			setVm();
			setAllValues();			
			local info = {};
			info.fillLevel = 0;
			if hasenzucht then
				info.fillLevel = Utils.getNoNil(objectTable.numHase, 0);
			elseif lammzucht then
				info.fillLevel = Utils.getNoNil(objectTable.numLamm, 0);
			else
				info.fillLevel = Utils.getNoNil(objectTable.numSchweine, 0);
			end;
			info.capacity = -1;
			local key = "FILLTYPE_"..string.upper(objectTable.name);
			info.pricePerLiter = getAnimalPrice(self, objectTable.name); --Fillable[key]);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_buy"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;			
			if objectTable.manureHeap ~= nil then
				local info = {};
				info.fillLevel = Utils.getNoNil(objectTable.manureHeap.FillLvl, 0);
				if info.fillLevel > 0 then
					info.capacity = 0;
					info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_MANURE);
					info.fillTypeName = tostring(moLanguageXml:getTxt("a_manure", nil, "Manure"));		
					info.lengthFillTypes = 1;
					outputFillTypes[container] = {};
					table.insert(outputFillTypes[container], info);
					container = container+1;			
				end;
			end;
			if objectTable.liquidManureSiloTrigger ~= nil then
				local info = {};
				info.fillLevel = Utils.getNoNil(objectTable.liquidManureSiloTrigger.fillLevel, 0);
				if info.fillLevel > 0 then
					info.capacity = 0;
					info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_LIQUIDMANURE);
					info.fillTypeName = tostring(moLanguageXml:getTxt("a_liquidmanure", nil, "LiquidManure"));		
					info.lengthFillTypes = 1;
					outputFillTypes[container] = {};
					table.insert(outputFillTypes[container], info);
					container = container+1;
				end;
			end;			
			if objectTable.palSammler ~= nil then
				for k, objectPal in pairs(objectTable.palSammler) do
					local info = {};
					info.capacity = 0;
					info.fillLevel = 0;
					info.container = container;					
					info.fillTypeName = moLanguageXml:getTxt("palsammler", nil, "PalCollector");
					info.lengthFillTypes = 1;
					info.pricePerLiter = 0;
					info.setColor = moGuiMiniPdaSlots.warningColor0
					local objCreate = objectTable.palSammler[k];			
					local fremdObj = nil;
					local full = false;
					if not MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then
						fremdObj = objCreate.fremdObject;
					elseif objCreate.Lamp ~= nil and objCreate.Lamp[1].s ~= nil then
						if objCreate.Lamp[1].s == 1 then fremdObj = 1;end;
						if objCreate.Lamp[1].s == 3 then full = true;end;
					end;				
					info.capacity = Utils.getNoNil(table.getn(objCreate.Points), 1);
					local noticePal = 0;				
					if info.capacity > 1 then
						if not full then
							for i = 1, info.capacity do
								if not MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then							
									if objCreate.Points[i].Pallet ~= nil then
										noticePal = noticePal+1;							
									end;
								elseif objCreate.Points[i].node2 ~= nil and moFillablePallet ~= nil then							
									local x, y, z = getWorldTranslation(objCreate.Points[i].node2);
									x = tonumber(math.floor(x + .5));
									y = tonumber(math.floor(y + .5));
									z = tonumber(math.floor(z + .5));							
									for nodeId, mapFillablePal in pairs(moFillablePallet) do							
										if moFillablePallet[nodeId].x == x and moFillablePallet[nodeId].z == z and moFillablePallet[nodeId].fillLevel >= 0.1 then
											noticePal = noticePal+1;
											break;
										end;
									end;
								end;
							end;
						else
							noticePal = info.capacity;
						end;
					end;							
					info.fillLevel = info.fillLevel+noticePal;
					if fremdObj ~= nil and fremdObj > 0 then 
						info.fillTypeName = moLanguageXml:getTxt("palsammlerblocked", nil, "Blocked !!");
						info.setColor = moGuiMiniPdaSlots.warningColor2;
					else
						if info.fillLevel >= info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor4;end;
						if info.fillLevel >= info.capacity/2 and info.fillLevel < info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
					end;
					outputFillTypes[container] = {};
					table.insert(outputFillTypes[container], info);
					container = container+1;
				end;
			end;
			container = 1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[4], 0); --mischration
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_forage"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[1], 0); --grainFruit
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_grainfruit"));		
			if hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_greenfruit"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[2], 0); --earthFruit
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_earthfruit"));		
			if hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_silofruit"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[3], 0); --siloFutter (Silage)
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_silofruit"));
			if hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_pelletfruit"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			if lammzucht then
				local info = {};
				info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[7], 0); --milk
				info.capacity = 0;
				info.pricePerLiter = 0;
				info.fillTypeName = tostring(moLanguageXml:getTxt("a_milk"));		
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[5], 0); --water
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[6], 0); --straw
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);		
		end;	
	end;
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputSr:getSrOld(self, objectTable, xmlModString)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	local hasenzucht = false;
	local lammzucht = false;
	local srzucht = false;
	if objectTable ~= nil then
		if objectTable.HaseZuchtDirtyFlag ~= nil then
			if objectTable.numRabbit > 0 or objectTable.numHase > 0 then hasenzucht = true;end;			
		end;
		if objectTable.LammZuchtDirtyFlag ~= nil then
			if objectTable.numLamb > 0 or objectTable.numLamm > 0 then lammzucht = true;end;			
		end;
		if objectTable.SchweineZuchtDirtyFlag ~= nil then
			if objectTable.numPig > 0 or objectTable.numSchweine > 0 then srzucht = true;end;			
		end;
		if hasenzucht or lammzucht or srzucht then
			function setVm()
				if moGeneralSettings.viehmarkt then
					if moMapObjects.vm[1] == nil then return;end;
					for a=1, table.getn(moMapObjects.vm) do							
						for k, v in pairs(moMapObjects.vm[a].fillTypes) do							
							if moFillTypes[v] ~= nil and moFillTypes[v].descName ~= nil then
								fillName = moFillTypes[v].descName;								
								if string.find(fillName, "Missing") then							
									local splitMissing = Utils.splitString(" ", fillName);
									fillName = splitMissing[2]
								end;								
								if string.find(string.lower(fillName), xmlModString) and moMapObjects.vm[a].priceMultipliers[moMapObjects.vm[a].fillTypes[k]] ~= nil then
									local info = {};
									info.fillLevel = 0;
									info.capacity = -2;									
									info.pricePerLiter = getVmPrice(self, xmlModString, moMapObjects.vm[a].priceMultipliers[moMapObjects.vm[a].fillTypes[k]]);
									info.fillTypeName = tostring(moLanguageXml:getTxt("a_vm", nil, "Animalmarket"));	
									info.extraText = tostring(moLanguageXml:getTxt("on", nil, "On"));
									info.setColor = moGuiMiniPdaSlots.warningColor1;
									info.lengthFillTypes = 1;
									outputFillTypes[container] = {};
									table.insert(outputFillTypes[container], info);
									container = container+1;
								end;									
							end;
						end;
					end;
				end;
			end;
			function setAllValues()		
				local info = {};
				local srTyp = tostring(moLanguageXml:getTxt("a_breeding", nil, "(breeding)"));
				if objectTable.fattening ~= nil and objectTable.fattening then srTyp = tostring(moLanguageXml:getTxt("a_mast", nil, "(mast)"));end;
				info.fillTypeName = getAnimalRegName(self, xmlModString).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount")).. tostring(srTyp);
				info.lengthFillTypes = 1;
				info.pricePerLiter = getAnimalStorePrice(self, objectTable.name);		
				info.fillLevel = 0;
				if hasenzucht then
					info.fillLevel = Utils.getNoNil(objectTable.numRabbit, 0);
				elseif lammzucht then
					info.fillLevel = Utils.getNoNil(objectTable.numLamb, 0);
				else
					info.fillLevel = Utils.getNoNil(objectTable.numPig, 0);
				end;
				info.capacity = -1;
				info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.Produktivi*100, 0));--Utils.getNoNil(objectTable.Produktivi*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
				info.productivityColor = getAnimalsProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];				
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;		
			end;
			setVm();
			setAllValues();			
			local info = {};
			info.fillLevel = 0;
			if hasenzucht then
				info.fillLevel = Utils.getNoNil(objectTable.numHase, 0);
			elseif lammzucht then
				info.fillLevel = Utils.getNoNil(objectTable.numLamm, 0);
			else
				info.fillLevel = Utils.getNoNil(objectTable.numSchweine, 0);
			end;
			info.capacity = -1;
			local key = "FILLTYPE_"..string.upper(objectTable.name);
			info.pricePerLiter = getAnimalPrice(self, objectTable.name); --Fillable[key]);
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_buy"));		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;			
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.manureHeap.FillLvl, 0);
			if info.fillLevel > 0 then
				info.capacity = 0;
				info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_MANURE);
				info.fillTypeName = tostring(moLanguageXml:getTxt("a_manure", nil, "Manure"));		
				info.lengthFillTypes = 1;
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;			
			end;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.liquidManureSiloTrigger.fillLevel, 0);
			if info.fillLevel > 0 then
				info.capacity = 0;
				info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_LIQUIDMANURE);
				info.fillTypeName = tostring(moLanguageXml:getTxt("a_liquidmanure", nil, "LiquidManure"));		
				info.lengthFillTypes = 1;
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;
			end;			
			if objectTable.palSammler ~= nil then
				for k, objectPal in pairs(objectTable.palSammler) do
					local info = {};
					info.capacity = 0;
					info.fillLevel = 0;
					info.container = container;					
					info.fillTypeName = moLanguageXml:getTxt("palsammler", nil, "PalCollector");
					info.lengthFillTypes = 1;
					info.pricePerLiter = 0;
					info.setColor = moGuiMiniPdaSlots.warningColor0
					local objCreate = objectTable.palSammler[k];			
					local fremdObj = objCreate.fremdObject;
					if fremdObj ~= nil and fremdObj > 0 then info.fillTypeName = moLanguageXml:getTxt("palsammlerblocked", nil, "Blocked !!");end;
					info.capacity = Utils.getNoNil(table.getn(objCreate.Points), 1);
					local noticePal = 0;
					if info.capacity > 1 then
						for i = 1, info.capacity do
							if objCreate.Points[i].Pallet ~= nil then
								noticePal = noticePal+1;					
							end;
						end;
					end;			
					info.fillLevel = info.fillLevel+noticePal;			
					if info.fillLevel >= info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor4;end;
					if info.fillLevel >= info.capacity/2 and info.fillLevel < info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor2;end;			
					if fremdObj ~= nil and fremdObj > 0 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
					outputFillTypes[container] = {};
					table.insert(outputFillTypes[container], info);
					container = container+1;
				end;
			end;
			container = 1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[4], 0); --mischration
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_forage"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[1], 0); --grainFruit
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_grainfruit"));		
			if g_i18n:hasText("green_fruits") or hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_greenfruit"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[2], 0); --earthFruit
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_earthfruit"));		
			if hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_rabbitpellet"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[3], 0); --siloFutter (Silage)
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_silage"));
			if g_i18n:hasText("pellet_fruits") or hasenzucht then info.fillTypeName = tostring(moLanguageXml:getTxt("a_pelletfruit"));end;
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			if lammzucht then
				local info = {};
				info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[7], 0); --milk
				info.capacity = 0;
				info.pricePerLiter = 0;
				info.fillTypeName = tostring(moLanguageXml:getTxt("a_milk"));		
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[5], 0); --water
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_watertrough"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);
			container = container+1;
			local info = {};
			info.fillLevel = Utils.getNoNil(objectTable.FutterTypLvl[6], 0); --straw
			info.capacity = 0;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw"));		
			info.lengthFillTypes = 1;
			inputFillTypes[container] = {};
			table.insert(inputFillTypes[container], info);		
		end;	
	end;
	return inputFillTypes, outputFillTypes	
end;

function getAnimalsProductivityColor(self, productivity)
	local ratio = productivity;
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		color = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		color = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		color = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		color = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	return color;
end;

function getAnimalRegName(self, name)
	local animalName = tostring(moLanguageXml:getTxt("unknow"));
	local languageName = tostring(moLanguageXml:getTxt(xmlModString));
	if string.find(languageName, "L ") then
		local desc = Fillable.fillTypeNameToDesc[name];
		if desc ~= nil and moFillTypes[desc.index] ~= nil then
			animalName = moFillTypes[desc.index].fruitName;
		end;		
	else
		animalName = languageName;
	end;
	return animalName;
end;

function getFruitPrice(self, fillType)	
	local bestPrice = 0;	
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		bestPrice = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
		--print("money.............".. tostring(g_i18n:formatMoney(bestPrice)))
		--print("money.............".. tostring(string.format("%0.1f", Utils.getNoNil(bestPrice, 0))));
	end;
	return bestPrice;
end;

function getAnimalStorePrice(self, name)	
	local bestPrice = 0;	
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[name];
	if storeItem ~= nil then
		bestPrice = storeItem.price;
	end;
	return bestPrice;
end;

function getAnimalPrice(self, name)	
	local bestPrice = 0;	
	local desc = Fillable.fillTypeNameToDesc[name];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		bestPrice = moFillTypes[desc.index].pricePerLiter/1000*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
	end;
	return bestPrice;
end;

function getVmPrice(self, name, priceMultiplier)	
	local bestPrice = 0;
	local desc = Fillable.fillTypeNameToDesc[name];
	local difficultyMultiplier = math.max((g_currentMission.missionStats.difficulty - 3)*2, 1) ---ist falsch deklariert in viehmarkt.lua, richtig wäre "math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1)"
	--if not old then difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);end;
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		bestPrice = moFillTypes[desc.index].pricePerLiter*priceMultiplier*difficultyMultiplier; --moGeneralSettings.difficultyMultiplier;
	end;		
	return bestPrice;
end;